--- /homez.786/ridinteadu/_serious_analysis/van_21.0.0/dolibarr-21.0.0/htdocs/product/stock/stockatdate.php	2025-03-03 15:58:17.000000000 +0000
+++ /homez.786/ridinteadu/seriousbeta/dolibarr/htdocs/product/stock/stockatdate.php	2025-03-17 14:05:55.243517000 +0000
@@ -29,12 +29,12 @@
 
 // Load Dolibarr environment
 require '../../main.inc.php';
-require_once DOL_DOCUMENT_ROOT.'/product/class/product.class.php';
-require_once DOL_DOCUMENT_ROOT.'/product/stock/class/entrepot.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/html.formother.class.php';
-require_once DOL_DOCUMENT_ROOT.'/core/class/html.form.class.php';
-require_once DOL_DOCUMENT_ROOT.'/fourn/class/fournisseur.commande.class.php';
-require_once DOL_DOCUMENT_ROOT.'/product/class/html.formproduct.class.php';
+require_once DOL_DOCUMENT_ROOT . '/product/class/product.class.php';
+require_once DOL_DOCUMENT_ROOT . '/product/stock/class/entrepot.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/html.formother.class.php';
+require_once DOL_DOCUMENT_ROOT . '/core/class/html.form.class.php';
+require_once DOL_DOCUMENT_ROOT . '/fourn/class/fournisseur.commande.class.php';
+require_once DOL_DOCUMENT_ROOT . '/product/class/html.formproduct.class.php';
 require_once './lib/replenishment.lib.php';
 
 /**
@@ -150,25 +150,27 @@
 	$warehouseStatus[] = Entrepot::STATUS_OPEN_INTERNAL;
 }
 
+
+
 // Get array with current stock per product, warehouse
 $stock_prod_warehouse = array();
 $stock_prod = array();
 if ($date && $dateIsValid) {	// Avoid heavy sql if mandatory date is not defined
 	$sql = "SELECT ps.fk_product, ps.fk_entrepot as fk_warehouse,";
 	$sql .= " SUM(ps.reel) AS stock";
-	$sql .= " FROM ".MAIN_DB_PREFIX."product_stock as ps";
-	$sql .= ", ".MAIN_DB_PREFIX."entrepot as w";
-	$sql .= ", ".MAIN_DB_PREFIX."product as p";
-	$sql .= " WHERE w.entity IN (".getEntity('stock').")";
+	$sql .= " FROM " . MAIN_DB_PREFIX . "product_stock as ps";
+	$sql .= ", " . MAIN_DB_PREFIX . "entrepot as w";
+	$sql .= ", " . MAIN_DB_PREFIX . "product as p";
+	$sql .= " WHERE w.entity IN (" . getEntity('stock') . ")";
 	$sql .= " AND w.rowid = ps.fk_entrepot AND p.rowid = ps.fk_product";
 	if (getDolGlobalString('ENTREPOT_EXTRA_STATUS') && count($warehouseStatus)) {
-		$sql .= " AND w.statut IN (".$db->sanitize(implode(',', $warehouseStatus)).")";
+		$sql .= " AND w.statut IN (" . $db->sanitize(implode(',', $warehouseStatus)) . ")";
 	}
 	if ($productid > 0) {
-		$sql .= " AND ps.fk_product = ".((int) $productid);
+		$sql .= " AND ps.fk_product = " . ((int) $productid);
 	}
 	if (! empty($search_fk_warehouse)) {
-		$sql .= " AND ps.fk_entrepot IN (".$db->sanitize(implode(",", $search_fk_warehouse)).")";
+		$sql .= " AND ps.fk_entrepot IN (" . $db->sanitize(implode(",", $search_fk_warehouse)) . ")";
 	}
 	if ($search_ref) {
 		$sql .= natural_search("p.ref", $search_ref);
@@ -178,6 +180,7 @@
 	}
 	$sql .= " GROUP BY fk_product, fk_entrepot";
 	//print $sql;
+	// var_dump("Premire requete" . $sql);
 
 	$resql = $db->query($sql);
 	if ($resql) {
@@ -213,30 +216,30 @@
 $movements_prod_nb = array();
 if ($date && $dateIsValid) {
 	$sql = "SELECT sm.fk_product, sm.fk_entrepot, SUM(sm.value) AS stock, COUNT(sm.rowid) AS nbofmovement";
-	$sql .= " FROM ".MAIN_DB_PREFIX."stock_mouvement as sm";
-	$sql .= ", ".MAIN_DB_PREFIX."entrepot as w";
-	$sql .= ", ".MAIN_DB_PREFIX."product as p";
-	$sql .= " WHERE w.entity IN (".getEntity('stock').")";
+	$sql .= " FROM " . MAIN_DB_PREFIX . "stock_mouvement as sm";
+	$sql .= ", " . MAIN_DB_PREFIX . "entrepot as w";
+	$sql .= ", " . MAIN_DB_PREFIX . "product as p";
+	$sql .= " WHERE w.entity IN (" . getEntity('stock') . ")";
 	$sql .= " AND w.rowid = sm.fk_entrepot AND p.rowid = sm.fk_product ";
 	if (getDolGlobalString('ENTREPOT_EXTRA_STATUS') && count($warehouseStatus)) {
-		$sql .= " AND w.statut IN (".$db->sanitize(implode(',', $warehouseStatus)).")";
+		$sql .= " AND w.statut IN (" . $db->sanitize(implode(',', $warehouseStatus)) . ")";
 	}
 	if ($mode == 'future') {
-		$sql .= " AND sm.datem <= '".$db->idate($dateendofday)."'";
+		$sql .= " AND sm.datem <= '" . $db->idate($dateendofday) . "'";
 	} else {
-		$sql .= " AND sm.datem >= '".$db->idate($dateendofday)."'";
+		$sql .= " AND sm.datem >= '" . $db->idate($dateendofday) . "'";
 	}
 	if ($productid > 0) {
-		$sql .= " AND sm.fk_product = ".((int) $productid);
+		$sql .= " AND sm.fk_product = " . ((int) $productid);
 	}
 	if (!empty($search_fk_warehouse)) {
-		$sql .= " AND sm.fk_entrepot IN (".$db->sanitize(implode(",", $search_fk_warehouse)).")";
+		$sql .= " AND sm.fk_entrepot IN (" . $db->sanitize(implode(",", $search_fk_warehouse)) . ")";
 	}
 	if ($search_ref) {
-		$sql .= " AND p.ref LIKE '%".$db->escape($search_ref)."%' ";
+		$sql .= " AND p.ref LIKE '%" . $db->escape($search_ref) . "%' ";
 	}
 	if ($search_nom) {
-		$sql .= " AND p.label LIKE '%".$db->escape($search_nom)."%' ";
+		$sql .= " AND p.label LIKE '%" . $db->escape($search_nom) . "%' ";
 	}
 	$sql .= " GROUP BY sm.fk_product, sm.fk_entrepot";
 
@@ -299,23 +302,23 @@
 $reshook = $hookmanager->executeHooks('printFieldListSelect', $parameters); // Note that $action and $object may have been modified by hook
 $sql .= $hookmanager->resPrint;
 
-$sql .= ' FROM '.MAIN_DB_PREFIX.'product as p';
+$sql .= ' FROM ' . MAIN_DB_PREFIX . 'product as p';
 if (!empty($search_fk_warehouse)) {
-	$sql .= ' LEFT JOIN '.MAIN_DB_PREFIX.'product_stock as ps ON p.rowid = ps.fk_product AND ps.fk_entrepot IN ('.$db->sanitize(implode(",", $search_fk_warehouse)).")";
+	$sql .= ' LEFT JOIN ' . MAIN_DB_PREFIX . 'product_stock as ps ON p.rowid = ps.fk_product AND ps.fk_entrepot IN (' . $db->sanitize(implode(",", $search_fk_warehouse)) . ")";
 }
 // Add fields from hooks
 $parameters = array();
 $reshook = $hookmanager->executeHooks('printFieldListJoin', $parameters); // Note that $action and $object may have been modified by hook
 $sql .= $hookmanager->resPrint;
-$sql .= ' WHERE p.entity IN ('.getEntity('product').')';
+$sql .= ' WHERE p.entity IN (' . getEntity('product') . ')';
 if ($productid > 0) {
-	$sql .= " AND p.rowid = ".((int) $productid);
+	$sql .= " AND p.rowid = " . ((int) $productid);
 }
 if (!getDolGlobalString('STOCK_SUPPORTS_SERVICES')) {
 	$sql .= " AND p.fk_product_type = 0";
 }
 if (!empty($canvas)) {
-	$sql .= " AND p.canvas = '".$db->escape($canvas)."'";
+	$sql .= " AND p.canvas = '" . $db->escape($canvas) . "'";
 }
 if ($search_ref) {
 	$sql .= natural_search('p.ref', $search_ref);
@@ -325,6 +328,11 @@
 }
 $sql .= ' GROUP BY p.rowid, p.ref, p.label, p.description, p.price, p.pmp, p.price_ttc, p.price_base_type, p.fk_product_type, p.desiredstock, p.seuil_stock_alerte,';
 $sql .= ' p.tms, p.duration, p.tobuy, p.stock';
+
+//MODIF JOSE
+if (!empty($search_fk_warehouse) || $search_fk_warehouse == 0) {
+	$sql .= ' HAVING SUM(ps.reel) > 0 OR SUM(p.pmp * ps.reel) > 0 ';
+}
 // Add where from hooks
 $parameters = array();
 $reshook = $hookmanager->executeHooks('printFieldListWhere', $parameters); // Note that $action and $object may have been modified by hook
@@ -339,6 +347,52 @@
 $sql .= $db->order($sortfield, $sortorder);
 
 $nbtotalofrecords = '';
+
+//MODIF JOSE
+$result = $db->query($sql);
+$total_buying_price = 0;
+$total_current_stock = 0;
+$total_virtual_stock = 0;
+
+if ($result) {
+	while ($objp = $db->fetch_object($result)) {
+		$currentstock = 0;
+		if (!empty($search_fk_warehouse)) {
+			foreach ($search_fk_warehouse as $val) {
+				if (!is_numeric($currentstock)) {
+					$currentstock = 0;
+				}
+				$currentstock += isset($stock_prod_warehouse[$objp->rowid][$val]) ? (float) $stock_prod_warehouse[$objp->rowid][$val] : 0;
+			}
+		} else {
+			$currentstock = isset($stock_prod[$objp->rowid]) ? (float) $stock_prod[$objp->rowid] : 0;
+		}
+
+		$stock = $currentstock;
+		if (!empty($search_fk_warehouse)) {
+			foreach ($search_fk_warehouse as $val) {
+				$stock -= isset($movements_prod_warehouse[$objp->rowid][$val]) ? (float) $movements_prod_warehouse[$objp->rowid][$val] : 0;
+			}
+		} else {
+			$stock -= isset($movements_prod[$objp->rowid]) ? (float) $movements_prod[$objp->rowid] : 0;
+		}
+
+		$total_current_stock += $currentstock;
+		$total_buying_price += $stock * $objp->pmp;
+		$total_virtual_stock += isset($objp->sellvalue) ? (float) $objp->sellvalue : 0;
+
+		$_GET['total_current_stock'] = $objforcount->total_ht ?? 0;
+		$_GET['total_buying_price'] = $objforcount->total_tva ?? 0;
+		$_GET['total_virtual_stock'] = $objforcount->total_ttc ?? 0;
+	}
+	$db->free($result);
+} else {
+	dol_print_error($db);
+}
+
+//END MODIF JOSE 
+
+
 if ($date && $dateIsValid) {	// We avoid a heavy sql if mandatory parameter date not yet defined
 	if (!getDolGlobalInt('MAIN_DISABLE_FULL_SCANLIST')) {
 		$result = $db->query($sql);
@@ -379,22 +433,22 @@
 if ($ext == 'csv') {
 	top_httphead("text/csv");
 	//header("Content-Type: text/csv");
-	header("Content-Disposition: attachment; filename=stock".($date ? '-'.date("Y-m-d", $date) : '').".csv");
+	header("Content-Disposition: attachment; filename=stock" . ($date ? '-' . date("Y-m-d", $date) : '') . ".csv");
 
 	// Lines of title
 	print implode(";", ($mode == 'future') ?
-		array('"Product Reference"', '"Label"', '"Current Stock"', '"'.$stocklabel.'"', '"Virtual Stock"') :
-		array('"Product Reference"', '"Label"', '"'.$stocklabel.'"', '"Estimated Stock Value"', '"Estimate Sell Value"', '"Movements"', '"Current Stock"'))."\r\n";
+		array('"Product Reference"', '"Label"', '"Current Stock"', '"' . $stocklabel . '"', '"Virtual Stock"') :
+		array('"Product Reference"', '"Label"', '"' . $stocklabel . '"', '"Estimated Stock Value"', '"Estimate Sell Value"', '"Movements"', '"Current Stock"')) . "\r\n";
 } else {
 	llxHeader('', $title, $helpurl, '', 0, 0, '', '', '', 'mod-product page-stock_stockatdate');
 
 	$head = array();
 
-	$head[0][0] = DOL_URL_ROOT.'/product/stock/stockatdate.php';
+	$head[0][0] = DOL_URL_ROOT . '/product/stock/stockatdate.php';
 	$head[0][1] = $langs->trans("StockAtDateInPast");
 	$head[0][2] = 'stockatdatepast';
 
-	$head[1][0] = DOL_URL_ROOT.'/product/stock/stockatdate.php?mode=future';
+	$head[1][0] = DOL_URL_ROOT . '/product/stock/stockatdate.php?mode=future';
 	$head[1][1] = $langs->trans("StockAtDateInFuture");
 	$head[1][2] = 'stockatdatefuture';
 
@@ -407,26 +461,26 @@
 	if ($mode == 'future') {
 		$desc = $langs->trans("StockAtDateFutureDesc");
 	}
-	print '<span class="opacitymedium">'.$desc.'</span><br>'."\n";
-	print '<br>'."\n";
+	print '<span class="opacitymedium">' . $desc . '</span><br>' . "\n";
+	print '<br>' . "\n";
 
-	print '<form name="formFilterWarehouse" method="POST" action="'.$_SERVER["PHP_SELF"].'">';
-	print '<input type="hidden" name="token" value="'.newToken().'">';
+	print '<form name="formFilterWarehouse" method="POST" action="' . $_SERVER["PHP_SELF"] . '">';
+	print '<input type="hidden" name="token" value="' . newToken() . '">';
 	print '<input type="hidden" name="action" value="filter">';
-	print '<input type="hidden" name="mode" value="'.$mode.'">';
+	print '<input type="hidden" name="mode" value="' . $mode . '">';
 
 	print '<div class="inline-block valignmiddle" style="padding-right: 20px;">';
-	print '<span class="fieldrequired">'.$langs->trans('Date').'</span> '.$form->selectDate(($date ? $date : -1), 'date');
+	print '<span class="fieldrequired">' . $langs->trans('Date') . '</span> ' . $form->selectDate(($date ? $date : -1), 'date');
 
 	print ' <span class="clearbothonsmartphone marginleftonly paddingleftonly marginrightonly paddingrightonly">&nbsp;</span> ';
-	print img_picto('', 'product', 'class="pictofixedwidth"').' ';
+	print img_picto('', 'product', 'class="pictofixedwidth"') . ' ';
 	print '</span> ';
 	print $form->select_produits($productid, 'productid', '', 0, 0, -1, 2, '', 0, array(), 0, $langs->trans('Product'), 0, 'maxwidth300', 0, '', null, 1);
 
 	if ($mode != 'future') {
 		// A virtual stock in future has no sense on a per warehouse view, so no filter on warehouse is available for stock at date in future
 		print ' <span class="clearbothonsmartphone marginleftonly paddingleftonly marginrightonly paddingrightonly">&nbsp;</span> ';
-		print img_picto('', 'stock', 'class="pictofixedwidth"').$langs->trans("Warehouse").' :';
+		print img_picto('', 'stock', 'class="pictofixedwidth"') . $langs->trans("Warehouse") . ' :';
 		print '</span> ';
 		$selected = ((GETPOSTISSET('search_fk_warehouse') || GETPOSTISSET('fk_warehouse')) ? $search_fk_warehouse : 'ifonenodefault');
 		print $formproduct->selectWarehouses($selected, 'search_fk_warehouse', '', 1, 0, 0, $langs->trans('Warehouse'), 0, 0, array(), 'minwidth200', array(), 1, false, 'e.ref', 1);
@@ -441,53 +495,69 @@
 	}
 
 	print '<div class="inline-block valignmiddle">';
-	print '<input type="submit" class="button" name="valid" value="'.$langs->trans('Refresh').'">';
+	print '<input type="submit" class="button" name="valid" value="' . $langs->trans('Refresh') . '">';
 	print '</div>';
 
 	//print '</form>';
 
 	$param = '';
 	if (!empty($contextpage) && $contextpage != $_SERVER["PHP_SELF"]) {
-		$param .= '&contextpage='.urlencode($contextpage);
+		$param .= '&contextpage=' . urlencode($contextpage);
 	}
 	if ($limit > 0 && $limit != $conf->liste_limit) {
-		$param .= '&limit='.((int) $limit);
+		$param .= '&limit=' . ((int) $limit);
 	}
-	$param .= '&mode='.$mode;
+	$param .= '&mode=' . $mode;
 	$param_warehouse = '';
 	if (!empty($search_fk_warehouse)) {
 		foreach ($search_fk_warehouse as $val) {
-			$param_warehouse .= '&search_fk_warehouse[]='.$val;
+			$param_warehouse .= '&search_fk_warehouse[]=' . $val;
 		}
 		$param .= $param_warehouse;
 	}
 	if ($productid > 0) {
-		$param .= '&productid='.(int) $productid;
+		$param .= '&productid=' . (int) $productid;
 	}
 	if (GETPOSTINT('dateday') > 0) {
-		$param .= '&dateday='.GETPOSTINT('dateday');
+		$param .= '&dateday=' . GETPOSTINT('dateday');
 	}
 	if (GETPOSTINT('datemonth') > 0) {
-		$param .= '&datemonth='.GETPOSTINT('datemonth');
+		$param .= '&datemonth=' . GETPOSTINT('datemonth');
 	}
 	if (GETPOSTINT('dateyear') > 0) {
-		$param .= '&dateyear='.GETPOSTINT('dateyear');
+		$param .= '&dateyear=' . GETPOSTINT('dateyear');
 	}
 
 	// TODO Move this into the title line ?
 	print_barre_liste('', $page, $_SERVER["PHP_SELF"], $param, $sortfield, $sortorder, '', $num, $nbtotalofrecords, 'stock', 0, '', '', $limit, 0, 0, 1);
 
+	// //MODIF JOSE
+	// if ($mode !== 'future' && !empty($date) && $dateIsValid) {
+
+	// 	print '<div style="display: flex; justify-content: center; gap: 20px; margin-bottom: 20px;">';
+	// 	printBox($langs->trans("Valorisation à l'achat"), price($total_buying_price));
+	// 	printBox($langs->trans("Stock actuel"), price($total_current_stock));
+	// 	if (!getDolGlobalString('PRODUIT_MULTIPRICES')) {
+	// 		printBox($langs->trans("Valeur vente"), price($total_virtual_stock));
+	// 	}
+
+	// 	print '</div>';
+	// }
+	// //END MODIF JOSE
+
+
+
 	print '<div class="div-table-responsive">'; // You can use div-table-responsive-no-min if you don't need reserved height for your table
 	if ($num) {
 		print '<p>';
-		print '<a href="stockatdate.php?output=csv&sortfield='.urlencode($sortfield).'&sortorder='.urlencode($sortorder).'&type='.((int) $type).'&mode='.urlencode($mode).
-			(($productid > 0) ? "&productid=".((int) $productid) : '').
-			$param_warehouse.
-			"&search_ref=".dol_escape_htmltag($search_ref).
-			"&search_nom=".dol_escape_htmltag($search_nom).
-			(GETPOSTISSET('dateday') ? "&dateday=".GETPOSTINT('dateday') : '').
-			(GETPOSTISSET('datemonth') ? "&datemonth=".GETPOSTINT('datemonth') : '').
-			(GETPOSTISSET('dateyear') ? "&dateyear=".GETPOSTINT('dateyear') : '').
+		print '<a href="stockatdate.php?output=csv&sortfield=' . urlencode($sortfield) . '&sortorder=' . urlencode($sortorder) . '&type=' . ((int) $type) . '&mode=' . urlencode($mode) .
+			(($productid > 0) ? "&productid=" . ((int) $productid) : '') .
+			$param_warehouse .
+			"&search_ref=" . dol_escape_htmltag($search_ref) .
+			"&search_nom=" . dol_escape_htmltag($search_nom) .
+			(GETPOSTISSET('dateday') ? "&dateday=" . GETPOSTINT('dateday') : '') .
+			(GETPOSTISSET('datemonth') ? "&datemonth=" . GETPOSTINT('datemonth') : '') .
+			(GETPOSTISSET('dateyear') ? "&dateyear=" . GETPOSTINT('dateyear') : '') .
 			'" title="Download CSV" />';
 		print img_picto('', 'download', 'class="pictofixedwidth"');
 		print 'Download CSV';
@@ -496,16 +566,16 @@
 	}
 	print '<table class="liste centpercent">';
 
-	print '<input type="hidden" name="token" value="'.newToken().'">';
-	print '<input type="hidden" name="sortfield" value="'.$sortfield.'">';
-	print '<input type="hidden" name="sortorder" value="'.$sortorder.'">';
-	print '<input type="hidden" name="type" value="'.$type.'">';
-	print '<input type="hidden" name="mode" value="'.$mode.'">';
+	print '<input type="hidden" name="token" value="' . newToken() . '">';
+	print '<input type="hidden" name="sortfield" value="' . $sortfield . '">';
+	print '<input type="hidden" name="sortorder" value="' . $sortorder . '">';
+	print '<input type="hidden" name="type" value="' . $type . '">';
+	print '<input type="hidden" name="mode" value="' . $mode . '">';
 
 	// Fields title search
 	print '<tr class="liste_titre_filter">';
-	print '<td class="liste_titre"><input class="flat" type="text" name="search_ref" size="8" value="'.dol_escape_htmltag($search_ref).'"></td>';
-	print '<td class="liste_titre"><input class="flat" type="text" name="search_nom" size="8" value="'.dol_escape_htmltag($search_nom).'"></td>';
+	print '<td class="liste_titre"><input class="flat" type="text" name="search_ref" size="8" value="' . dol_escape_htmltag($search_ref) . '"></td>';
+	print '<td class="liste_titre"><input class="flat" type="text" name="search_nom" size="8" value="' . dol_escape_htmltag($search_nom) . '"></td>';
 	print '<td class="liste_titre"></td>';
 	print '<td class="liste_titre"></td>';
 	print '<td class="liste_titre"></td>';
@@ -543,9 +613,9 @@
 		print_liste_field_titre('VirtualStock', $_SERVER["PHP_SELF"], '', $param, '', '', $sortfield, $sortorder, 'right ', 'VirtualStockDesc');
 	} else {
 		print_liste_field_titre($stocklabel, $_SERVER["PHP_SELF"], '', $param, '', '', $sortfield, $sortorder, 'right ');
-		$tooltiptext = $langs->trans("QtyAtDate").' x '.$langs->trans("AverageUnitPricePMPShort").' ('.$langs->trans("Currently").')';
+		$tooltiptext = $langs->trans("QtyAtDate") . ' x ' . $langs->trans("AverageUnitPricePMPShort") . ' (' . $langs->trans("Currently") . ')';
 		print_liste_field_titre("EstimatedStockValue", $_SERVER["PHP_SELF"], "estimatedvalue", '', $param, '', $sortfield, $sortorder, 'right ', $tooltiptext, 1);
-		$tooltiptext = $langs->trans("QtyAtDate").' x '.$langs->trans("SellingPrice").' ('.$langs->trans("Currently").')';
+		$tooltiptext = $langs->trans("QtyAtDate") . ' x ' . $langs->trans("SellingPrice") . ' (' . $langs->trans("Currently") . ')';
 		print_liste_field_titre("EstimatedStockValueSell", $_SERVER["PHP_SELF"], "", '', $param, '', $sortfield, $sortorder, 'right ', $tooltiptext, 1);
 		$tooltiptext = $langs->trans("MovementsSinceDate");
 		print_liste_field_titre('', $_SERVER["PHP_SELF"], '', '', $param, '', '', '', 'right ', $tooltiptext, 1);
@@ -562,6 +632,8 @@
 	print "</tr>\n";
 }
 
+
+
 $totalbuyingprice = 0;
 $totalsellingprice = 0;
 $totalcurrentstock = 0;
@@ -635,30 +707,43 @@
 		if ($ext == 'csv') {
 			if ($mode == 'future') {
 				print implode(";", array(
-					'"'.$objp->ref.'"',
-					'"'.$objp->label.'"',
-					'"'.price2num($currentstock, 'MS').'"',
-					'"'.price2num($stock, 'MS').'"',
-					'"'.price2num($virtualstock, 'MS').'"'))."\r\n";
+					'"' . $objp->ref . '"',
+					'"' . $objp->label . '"',
+					'"' . price2num($currentstock, 'MS') . '"',
+					'"' . price2num($stock, 'MS') . '"',
+					'"' . price2num($virtualstock, 'MS') . '"'
+				)) . "\r\n";
 				$totalvirtualstock += $virtualstock;
 			} else {
 				print implode(";", array(
-					'"'.$objp->ref.'"',
-					'"'.$objp->label.'"',
-					'"'.price(price2num($stock, 'MS')).'"',
-					price2num($stock * $objp->pmp, 'MT') ? '"'.price2num($stock * $objp->pmp, 'MT').'"' : '',
-					!getDolGlobalString('PRODUIT_MULTIPRICES') ? '"'.price2num($stock * $objp->price, 'MT').'"' : '"'.$langs->trans("Variable").'('.$langs->trans("OptionMULTIPRICESIsOn").')"',
+					'"' . $objp->ref . '"',
+					'"' . $objp->label . '"',
+					'"' . price(price2num($stock, 'MS')) . '"',
+					price2num($stock * $objp->pmp, 'MT') ? '"' . price2num($stock * $objp->pmp, 'MT') . '"' : '',
+					!getDolGlobalString('PRODUIT_MULTIPRICES') ? '"' . price2num($stock * $objp->price, 'MT') . '"' : '"' . $langs->trans("Variable") . '(' . $langs->trans("OptionMULTIPRICESIsOn") . ')"',
 					"$nbofmovement",
-					'"'.price2num($currentstock, 'MS').'"'))."\r\n";
+					'"' . price2num($currentstock, 'MS') . '"'
+				)) . "\r\n";
 				$totalbuyingprice += $stock * $objp->pmp;
 				$totalsellingprice += $stock * $objp->price;
 			}
 			$totalcurrentstock += $currentstock;
 		} else {
+
+			$estimatedvalue = $stock * $objp->pmp;
+
+			// if ($stock == 0 && $estimatedvalue == 0) {
+			// 	var_dump("Exclusion de la ligne :", $objp->ref, "Stock:", $stock, "Estimated Value:", $estimatedvalue);
+			// }
+
+			// if ($stock == 0) {
+			// 	continue;
+			// }
+
 			print '<tr class="oddeven">';
 
 			// Product ref
-			print '<td class="nowrap">'.$prod->getNomUrl(1, '').'</td>';
+			print '<td class="nowrap">' . $prod->getNomUrl(1, '') . '</td>';
 
 			// Product label
 			print '<td>';
@@ -667,26 +752,27 @@
 
 			if ($mode == 'future') {
 				// Current stock
-				print '<td class="right">'.price(price2num($currentstock, 'MS')).'</td>';
+				print '<td class="right">' . price(price2num($currentstock, 'MS')) . '</td>';
 				//$totalcurrentstock += $currentstock;
 
 				print '<td class="right"></td>';
 
 				// Virtual stock at date
-				print '<td class="right">'.price(price2num($stock, 'MS')).'</td>';
+				print '<td class="right">' . price(price2num($stock, 'MS')) . '</td>';
 
 				// Final virtual stock
-				print '<td class="right">'.price(price2num($virtualstock, 'MS')).'</td>';
+				print '<td class="right">' . price(price2num($virtualstock, 'MS')) . '</td>';
 				$totalvirtualstock += $virtualstock;
 			} else {
+
+
 				// Stock at date
-				print '<td class="right">'.($stock ? price(price2num($stock, 'MS')) : ('<span class="opacitymedium">0</span>')).'</td>';
+				print '<td class="right">' . ($stock ? price(price2num($stock, 'MS')) : ('<span class="opacitymedium">0</span>')) . '</td>';
 
 				// PMP value
-				$estimatedvalue = $stock * $objp->pmp;
-				print '<td class="right" title="'.dolPrintHTMLForAttribute($langs->trans("AverageUnitPricePMPShort").' ('.$langs->trans("Currently").'): '.price(price2num($objp->pmp, 'MU'), 1)).'">';
+				print '<td class="right" title="' . dolPrintHTMLForAttribute($langs->trans("AverageUnitPricePMPShort") . ' (' . $langs->trans("Currently") . '): ' . price(price2num($objp->pmp, 'MU'), 1)) . '">';
 				if (price2num($estimatedvalue, 'MT')) {
-					print '<span class="amount">'.price(price2num($estimatedvalue, 'MT'), 1).'</span>';
+					print '<span class="amount">' . price(price2num($estimatedvalue, 'MT'), 1) . '</span>';
 				} else {
 					print '';
 				}
@@ -696,7 +782,7 @@
 				// Selling value
 				print '<td class="right"';
 				if (!getDolGlobalString('PRODUIT_MULTIPRICES')) {
-					print ' title="'.dolPrintHTMLForAttribute($langs->trans("SellingPrice").' ('.$langs->trans("Currently").'): '.price(price2num($objp->price, 'MU'), 1));
+					print ' title="' . dolPrintHTMLForAttribute($langs->trans("SellingPrice") . ' (' . $langs->trans("Currently") . '): ' . price(price2num($objp->price, 'MU'), 1));
 				}
 				print '">';
 				if (!getDolGlobalString('PRODUIT_MULTIPRICES')) {
@@ -708,31 +794,31 @@
 					$totalsellingprice += $stock * $objp->price;
 				} else {
 					$htmltext = $langs->trans("OptionMULTIPRICESIsOn");
-					print $form->textwithtooltip('<span class="opacitymedium">'.$langs->trans("Variable").'</span>', $htmltext);
+					print $form->textwithtooltip('<span class="opacitymedium">' . $langs->trans("Variable") . '</span>', $htmltext);
 				}
 				print '</td>';
 
 				// Movements
 				print '<td class="right">';
 				if ($nbofmovement > 0) {
-					$url = DOL_URL_ROOT.'/product/stock/movement_list.php?idproduct='.$objp->rowid;
+					$url = DOL_URL_ROOT . '/product/stock/movement_list.php?idproduct=' . $objp->rowid;
 					if (GETPOSTISSET('datemonth')) {
-						$url .= '&search_date_startday='.GETPOSTINT('dateday');
-						$url .= '&search_date_startmonth='.GETPOSTINT('datemonth');
-						$url .= '&search_date_startyear='.GETPOSTINT('dateyear');
+						$url .= '&search_date_startday=' . GETPOSTINT('dateday');
+						$url .= '&search_date_startmonth=' . GETPOSTINT('datemonth');
+						$url .= '&search_date_startyear=' . GETPOSTINT('dateyear');
 					}
 					if (count($search_fk_warehouse) > 1) {
 						$url = '';	// Do not show link, multi warehouse as filter not managed yet by target page
 					} else {
 						foreach ($search_fk_warehouse as $val) {
-							$url .= ($val > 0 ? '&search_warehouse='.((int) $val) : '');
+							$url .= ($val > 0 ? '&search_warehouse=' . ((int) $val) : '');
 						}
 					}
 					if ($url) {
-						print '<a href="'.$url.'">';
+						print '<a href="' . $url . '">';
 					}
 					print $langs->trans("Movements");
-					print '<span class="tabs paddingleft"><span class="badge">'.$nbofmovement.'</span></span>';
+					print '<span class="tabs paddingleft"><span class="badge">' . $nbofmovement . '</span></span>';
 					if ($url) {
 						print '</a>';
 					}
@@ -740,7 +826,7 @@
 				print '</td>';
 
 				// Current stock
-				print '<td class="right">'.($currentstock ? price(price2num($currentstock, 'MS')) : '<span class="opacitymedium">0</span>').'</td>';
+				print '<td class="right">' . ($currentstock ? price(price2num($currentstock, 'MS')) : '<span class="opacitymedium">0</span>') . '</td>';
 			}
 			$totalcurrentstock += $currentstock;
 
@@ -752,7 +838,7 @@
 			// Action
 			print '<td class="right"></td>';
 
-			print '</tr>'."\n";
+			print '</tr>' . "\n";
 		}
 	}
 	$i++;
@@ -773,42 +859,44 @@
 	print implode(
 		";",
 		($mode == 'future') ? array(
-		'"'.$langs->trans("Totalforthispage").'"',
-		'',
-		$productid > 0 ? price2num($totalcurrentstock, 'MS') : '',
-		'',
-		price(price2num($totalvirtualstock, 'MS'))) :
-		array(
-		'"'.$langs->trans("Totalforthispage").'"',
-		'',
-		'',
-		'"'.price2num($totalbuyingprice, 'MT').'"',
-		!getDolGlobalString('PRODUIT_MULTIPRICES') ? '"'.price2num($totalsellingprice, 'MT').'"' : '',
-		'',
-		$productid > 0 ? price2num($totalcurrentstock, 'MS') : '')
+			'"' . $langs->trans("Totalforthispage") . '"',
+			'',
+			$productid > 0 ? price2num($totalcurrentstock, 'MS') : '',
+			'',
+			price(price2num($totalvirtualstock, 'MS'))
+		) :
+			array(
+				'"' . $langs->trans("Totalforthispage") . '"',
+				'',
+				'',
+				'"' . price2num($totalbuyingprice, 'MT') . '"',
+				!getDolGlobalString('PRODUIT_MULTIPRICES') ? '"' . price2num($totalsellingprice, 'MT') . '"' : '',
+				'',
+				$productid > 0 ? price2num($totalcurrentstock, 'MS') : ''
+			)
 	);
 } else {
 	if (empty($date) || !$dateIsValid) {
-		print '<tr><td colspan="'.$colspan.'"><span class="opacitymedium">'.$langs->trans("EnterADateCriteria").'</span></td></tr>';
+		print '<tr><td colspan="' . $colspan . '"><span class="opacitymedium">' . $langs->trans("EnterADateCriteria") . '</span></td></tr>';
 	} else {
 		print '<tr class="liste_total">';
-		print '<td>'.$langs->trans("Totalforthispage").'</td>';
+		print '<td>' . $langs->trans("Totalforthispage") . '</td>';
 		print '<td></td>';
 		if ($mode == 'future') {
-			print '<td class="right">'.price(price2num($totalcurrentstock, 'MS')).'</td>';
+			print '<td class="right">' . price(price2num($totalcurrentstock, 'MS')) . '</td>';
 			print '<td></td>';
 			print '<td></td>';
-			print '<td class="right">'.price(price2num($totalvirtualstock, 'MS')).'</td>';
+			print '<td class="right">' . price(price2num($totalvirtualstock, 'MS')) . '</td>';
 		} else {
 			print '<td></td>';
-			print '<td class="right">'.price(price2num($totalbuyingprice, 'MT')).'</td>';
+			print '<td class="right">' . price(price2num($totalbuyingprice, 'MT')) . '</td>';
 			if (!getDolGlobalString('PRODUIT_MULTIPRICES')) {
-				print '<td class="right">'.price(price2num($totalsellingprice, 'MT')).'</td>';
+				print '<td class="right">' . price(price2num($totalsellingprice, 'MT')) . '</td>';
 			} else {
 				print '<td></td>';
 			}
 			print '<td></td>';
-			print '<td class="right">'.($productid > 0 ? price(price2num($totalcurrentstock, 'MS')) : '').'</td>';
+			print '<td class="right">' . ($productid > 0 ? price(price2num($totalcurrentstock, 'MS')) : '') . '</td>';
 		}
 		print '<td></td>';
 		print '</tr>';

########## public/payment/paymentok.php
